#ifdef BEO
C**********************************************************************C
C***  Slave version just runs those parameters requested by master  ***C
C**********************************************************************C
      SUBROUTINE RUNSLAVE(IFAIL)                                               !jd
      USE PESTDATA
      IMPLICIT NONE
      ALLOCATABLE      PAR,OBS,NW,LL,LCINS,IIOBS,OBSN1,OBSN2,
     |                 PWORD,PARDEL,MRKDEL,A
      LOGICAL          BEOGET
      INTEGER          IFAIL                                                   !jd
      INTEGER          SVDA_PARSET                                             !jd
      INTEGER          SV                                                      !jd
      INTEGER          JFAIL,NP,NT,NS,ASIZE,NUML,NINSTR,IOS,ILINE,
     |                 INCPAR,NBLBMX,NCALL,MCALL,
     |                 NW(:),LL(:),LCINS(:),IIOBS(:),OBSN1(:),OBSN2(:)
      DOUBLE PRECISION PAR(:),OBS(:)
      CHARACTER        PARDEL(:),MRKDEL(:),A(:)
      CHARACTER*23     PWORD(:)
      CHARACTER*2000   BUF
      COMMON /MODCAL/  NCALL,MCALL

      IFAIL=0
      SVDA_PARSET=0                                                            !jd
      if (SVDA.eq.1) call INITIALISE_BASE(IFAIL,SVDA_SCALADJ)
      if (IFAIL.ne.0) call BEOFATAL('INITIALISE BASE failed')

C  Get parameter count NP and target count NT from master
C  Use this as a sanity check
      call BEOCAST(NP,NT,NS,SV)
      if (NP.ne.NPAR .or. NT.ne.NOBS) then
        print *,'NPAR Slave=',NPAR,' Master=',NP
        print *,'NOBS Slave=',NOBS,' Master=',NT
        call BEOFATAL('Par/Obs count mismatch between master and slave')
      endif
      if(SV.ne.SVDA)then                                                       !jd
        print *,'SVDA Slave=',SVDA,' Master=',SV                               !jd
        call BEOFATAL('SVDA mismatch between master and slave.')               !jd
      end if                                                                   !jd
C  Allocate memory for files, parameters and observations
      allocate(PARDEL(NTPLFLE),MRKDEL(NINSFLE),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE del failed')
      allocate(PAR(NPAR),NW(NPAR),PWORD(NPAR),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE par failed')
      allocate(OBS(NOBS),IIOBS(NOBS),OBSN1(NOBS),OBSN2(NOBS),STAT=IOS)
      if (IOS.ne.0) call BEOFATAL('ALLOCATE obs failed')

C  Wait for set of parameters
      MCALL = 0
      do while (BEOGET(PAR))
        MCALL = MCALL+1
        if(MCALL.eq.1)then
C  Read template and instruction files
        call IOCTL(JFAIL,NPAR,NTPLFLE,NINSFLE,NUML,ASIZE,NINSTR,NBLBMX,
     |  NW,TEMPFLE,INFLE,INSFLE,OUTFLE,PARDEL,MRKDEL,APAR,CLINE,ILINE)
        if (JFAIL.ne.0) call BEOFATAL('IOCTL failed')
C  Allocate memory for templates
        if (NUML.eq.0) NUML = 1
        allocate(A(ASIZE),LL(NUML),LCINS(NINSTR),STAT=IOS)
        if (IOS.ne.0) call BEOFATAL('ALLOCATE tpl/ins failed')
C  Read instruction file
        call READINS(LCINS,NINSTR,A,ASIZE,MRKDEL,JFAIL)
        if (IOS.ne.0) call BEOFATAL('READINS failed')
        end if
C  Write model input files
        INCPAR = 0
        call INWRIT(JFAIL,NPAR,PRECIS,NOPNT,NTPLFLE,NW,PAR,SCALE,
     |    OFFSET,PARDEL,PWORD,INFLE,TEMPFLE,APAR,CLINE,MESSFILE,INCPAR,
     |    ITRANS,NOBS)
        if (JFAIL.ne.0) call BEOFATAL('INWRIT failed')
C  Run model
        write(6,10)
10      format(/,' Running model ....')
        call SYSTEM(TRIM(COMLIN(1)))
        write(6,20)
20      format(' Model run complete.')
C  Read model output files
        call OUTRD(JFAIL,NINSTR,NINSFLE,ASIZE,NUML,NOBS,NBLBMX,LCINS,
     |             LL,OBSN1,OBSN2,IIOBS,OBS,AOBS,A,MRKDEL,CLINE,BUF)
        if (JFAIL.ne.0) print *,'OUTRD failed - continuing'
C  Send results back
        IF(JFAIL.EQ.0)THEN                                                !jd
          call BEOPUT(PAR,OBS)
        ELSE                                                              !jd
          OBS=-1.01D300                 !an array                         !jd
          call BEOPUT(PAR,OBS)                                            !jd
          IFAIL=1                                                         !jd
        END IF                                                            !jd
      enddo
C     print '(A,I6)','Total model calls:',MCALL

      RETURN                                                              !jd

      END
C**********************************************************************C
C******  Routine to schedule manage slaves to do series of jobs  ******C
C**********************************************************************C
C  STAT is node status
C   -1 = offline
C    0 = idle
C  k>0 = running job k
C
C  MODE is the job status
C   -1 = not run
C    0 = run
C  k>0 = running on node k
      SUBROUTINE RUNMASTER(PARREG,OBSREG,NJOB,JFAIL,
     +irestart,ptunit,pitn,ptfile,workvecdim,workvec)                       !jd
      USE PESTDATA
      USE BEOPEST
      USE BEORUN_DATA                                                       !jd
      use beopriv, only : strt,suspect,av_operating                         !jd
      IMPLICIT NONE
      integer          irestart,ptunit,pitn,workvecdim                      !jd
      integer          ierr,ptcount,titn,itemps,jj,icflag                   !jd
      integer          i,istopcount,jjfail,istop,waitflag                   !jd
      integer          dd,mm,yy,hh,min                                      !jd
      integer          bsn                                                  !jd
      real             ss                                                   !jd
C      ALLOCATABLE      MODE,STAT,PAR
      INTEGER          PARREG,OBSREG,NJOB,JFAIL,BEOSTAT,NCALL,MCALL,
C     |                 MODE(:),STAT(:),node,kjob,node0,node1,
     |                 node,kjob,node0,node1,                               !jd
     |                 idle,next,done,IOS
      double precision workvec(workvecdim)                                  !jd
C      DOUBLE PRECISION PAR(:),fast,BEOWALL
      DOUBLE PRECISION fast,BEOWALL
      double precision current_walltime,walltime,dtemp                      !jd
      double precision  average_time                                        !jd
      CHARACTER*256    BEOTEXT
      character*10     atemp,anode,ajob                                     !jd
      character*11     bresult1,bresult2,bresult                            !jd
      character*(*)    ptfile                                               !jd
      COMMON /MODCAL/  NCALL,MCALL
      COMMON /SSTOP/ISTOP                                                   !jd

      icflag=0                                                              !jd
      istopcount=0                                                          !jd
      waitflag=0                                                            !jd


C  Allocate memory for parameter and slave arrays
      if(ialloc_beorun_data.eq.0)then                                       !jd
        allocate(PAR(NPAR),MODE(NJOB),STAT(MAXNODE),STAT=IOS)               !jd
        if (IOS.ne.0)                                                       !jd
     +  call BEOFATAL('Cannot allocate memory in RUNMASTER')                !jd
        ialloc_beorun_data=1                                                !jd
        pardim=npar                                                         !jd
        modedim=njob                                                        !jd
        statdim=maxnode                                                     !jd
      else                                                                  !jd
        if(npar.gt.pardim)then                                              !jd
          deallocate(par,stat=ios)                                          !jd
          if(ios.ne.0) go to 5                                              !jd
          allocate(par(npar),stat=ios)                                      !jd
          if(ios.ne.0) go to 5                                              !jd
          pardim=npar                                                       !jd
        end if                                                              !jd
        if(njob.gt.modedim)then                                             !jd
          deallocate(mode,stat=ios)                                         !jd
          if(ios.ne.0) go to 5                                              !jd
          allocate(mode(njob),stat=ios)                                     !jd
          if(ios.ne.0) go to 5                                              !jd
          modedim=njob                                                      !jd
        end if                                                              !jd
        if(maxnode.gt.statdim)then                                          !jd
          deallocate(stat,stat=ios)                                         !jd
          if(ios.ne.0) go to 5                                              !jd
          allocate(stat(maxnode),stat=ios)                                  !jd
          if(ios.ne.0) go to 5                                              !jd
          statdim=maxnode                                                   !jd
        end if                                                              !jd
        go to 10                                                            !jd
5       call beofatal('Memory allocation error in RUNMASTER')               !jd
10      continue                                                            !jd
      end if                                                               !jd

C  Mark all slaves as dead
      STAT = -1
C  Mark all jobs as not run
      MODE = -1
C  kjob is the number of jobs completed
      kjob = 0

C -- The restart file situation is handled.                                 !jd
                                                                            !jd
        if(irestart.eq.1)then                                               !jd
          call ffopen(jfail,-ptunit,'w',ptfile,25,cline)                    !jd
          if(jfail.ne.0)then                                                !jd
            jfail=0                                                         !jd
            irestart=0                                                      !jd
            go to 1050                                                      !jd
          end if                                                            !jd
          write(ptunit,iostat=ierr)pitn                                     !jd
#ifdef FLUSHFILE
          call flush(ptunit)                                                !jd
#endif
        else if(irestart.eq.2)then                                          !jd
          ptcount=0                                                         !jd
          call ffopen(jfail,-ptunit,'r',ptfile,22,cline)                    !jd
          if(jfail.ne.0) then                                               !jd
            jfail=0                                                         !jd
            go to 2000                                                      !jd
          end if                                                            !jd
          titn=0                                                            !jd
          read(ptunit,iostat=ierr)titn                                      !jd
          if(pitn.ne.titn)then                                              !jd
            close(unit=ptunit,iostat=ierr,status='delete')                  !jd
            go to 2000                                                      !jd
          end if                                                            !jd
          do                                                                !jd
            read(ptunit,err=1900,end=1900) itemps                           !jd
            do jj=1,nobs                                                    !jd
              workvec(jj)=-1.1d300                                          !jd
            end do                                                          !jd
            mode(itemps)=0                                                  !jd
            ptcount=ptcount+1                                               !jd
            read(ptunit,err=1900,end=1900)                                  !jd
     +      (workvec(jj),jj=1,nobs)                                         !jd
            call store_parallel_register                                    !jd
     +      (jjfail,nobs,ippo,itemps,workvec,obsregfile)                    !jd
            if(jjfail.ne.0) go to 9891                                      !jd
          end do                                                            !jd
1900      close(unit=ptunit,status='delete',iostat=ierr)                    !jd
          if(itemps.ne.0)then                                               !jd
            do jj=1,nobs                                                    !jd
              if(workvec(jj).lt.-1.0d300)then                               !jd
                ptcount=ptcount-1                                           !jd
                mode(itemps)=-1                                             !jd
                go to 1901                                                  !jd
              end if                                                        !jd
            end do                                                          !jd
          end if                                                            !jd
1901      continue                                                          !jd
2000      continue                                                          !jd
#ifdef INTEL
          call writint(atemp,ptcount)                                       !jd
          write(6,1049) trim(atemp)                                         !jd
1049      format('    Results from ',a,                                     !jd
     +    ' model runs read from restart file.')                            !jd
          icflag=1                                                          !jd
#endif
          kjob=ptcount                                                      !jd
          ncall=ncall+ptcount                                               !jd
          call ffopen(jfail,-ptunit,'w',ptfile,25,cline)                    !jd
          if(jfail.ne.0)then                                                !jd
            jfail=0                                                         !jd
            irestart=0                                                      !jd
            go to 1050                                                      !jd
          end if                                                            !jd
          write(ptunit,iostat=ierr)pitn                                     !jd
          if(ptcount.ne.0)then                                              !jd
            do i=1,njob                                                     !jd
              if(mode(i).eq.0)then                                          !jd
                call retrieve_parallel_register                             !jd
     +          (jjfail,nobs,ippo,i,workvec,obsregfile)                     !jd
                if(jjfail.ne.0) go to 9891                                  !jd
                write(ptunit,iostat=ierr)i                                  !jd
                write(ptunit,iostat=ierr)(workvec(jj),jj=1,nobs)            !jd
              end if                                                        !jd
            end do                                                          !jd
          end if                                                            !jd
#ifdef FLUSHFILE
          call flush(ptunit)                                                !jd
#endif
          if(ptcount.eq.njob) go to 9999                                    !jd
        end if                                                              !jd
                                                                            !jd
1050    continue                                                            !jd

        call BEONODE(node0,node1)                                           !jd
        if(node1.lt.node0)then                                              !jd
          write(6,*)                                                        !jd
          write(6,1051)                                                     !jd
1051      format('    Waiting for at least one slave to appear....')        !jd
          waitflag=1                                                        !jd
        end if                                                              !jd

C  Launch jobs until all jobs are completed
      do while (kjob.lt.NJOB)

C -- See whether the escape key has been pressed.                          !jd
                                                                           !jd
        if(istopcount.eq.100)then                                          !jd
          istopcount=0                                                     !jd
          call stopress(0)                                                 !jd
          if((istop.eq.2).or.(istop.eq.1)) then                            !jd
            if(irestart.ne.0) close(unit=ptunit,iostat=ierr)               !jd
            go to 9999                                                     !jd
          end if                                                           !jd
        else                                                               !jd
          istopcount=istopcount+1                                          !jd
        end if                                                             !jd

C       Poll all slaves to check for a change in status
        call BEONODE(node0,node1)


        do node=node0,node1
C         Slave is idle
          bsn=BEOSTAT(NODE)                                                 !jd
          if (BSN.gt.0) then
C           Mark job as completed
            if (STAT(node).gt.0)then
              if(mode(stat(node)).gt.0)then                                 !jd
                kjob = kjob+1
#ifdef INTEL
                if((kjob.eq.1).or.(icflag.eq.1))then                          !jd
                  write(6,1010)                                               !jd
1010              format('    - number of runs completed...')                 !jd
                  write(6,'(a)',advance='no') '     '                         !jd
                  icflag=0                                                    !jd
                end if                                                        !jd
                write(6,1020) kjob                                            !jd
1020            format(i6,$)                                                  !jd
                if((kjob.eq.NJOB).or.(mod(kjob,12).eq.0))then                 !jd
                  write(6,*)                                                  !jd
                  write(6,'(a)',advance='no') '     '                         !jd
                end if                                                        !jd
#endif
                MODE(STAT(node)) = 0
C  Store  parameters and observations
                call BEOSTORE(node,STAT(node),PARREG,OBSREG,                  !jd
     +          irestart,ptunit)                                              !jd
C  Write to the run management file.
                call date_and_time(date=bresult1,time=bresult2)               !jd
C               read(bresult1,'(i4,i2,i2)') yy,mm,dd                          !jd
                read(bresult2,'(i2,i2,f6.0)') hh,min,ss                       !jd
                write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss       !jd
                if(bresult(7:7).eq.' ')bresult(7:7)='0'                       !jd
                call writint(anode,node)                                      !jd
                call writint(ajob,stat(node))                                 !jd
                write(irmr,1012) bresult,trim(ajob),trim(anode)               !jd
1012            format(3x,a,':- model run ',a,                                !jd
     +          ' completed on node ',a,'.')                                  !jd
#ifdef FLUSHFILE
                call flush(irmr)                                              !jd
#endif
                if(last_first_obs.lt.-1.0d300)then                            !jd
                  call writint(anode,node)                                    !jd
                  write(errmsg,1015) trim(anode),trim(beotext(node))          !jd
1015              format('Model run failure has occurred on node ',a,         !jd
     +            ' identified as "',a,'". See screen printout of ',          !jd
     +            'pertinent slave for error message details.')               !jd
                  go to 9891                                                  !jd
                else                                                          !jd
C -- Update average walltime.                                                 !jd
                  dtemp=beowall(node)                                         !jd
                  average_walltime=average_time(dtemp)                        !jd
                end if                                                        !jd
              else
                call date_and_time(date=bresult1,time=bresult2)               !jd
                read(bresult2,'(i2,i2,f6.0)') hh,min,ss                       !jd
                write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss       !jd
                if(bresult(7:7).eq.' ')bresult(7:7)='0'                       !jd
                call writint(anode,node)                                      !jd
                write(irmr,1018) bresult,trim(anode)                          !jd
1018            format(3x,a,':- model run completed on node ',a,              !jd
     +          '; old run so results not needed.')                           !jd
#ifdef FLUSHFILE
                call flush(irmr)                                              !jd
#endif
                dtemp=beowall(node)                                           !jd
                average_walltime=average_time(dtemp)                          !jd
              endif
            end if
C           Mark slave as idle
            STAT(node) = 0
            suspect(node)=0
C  Slave has died
          else if (bsn.lt.0) then
C  Reschedule job
            if (STAT(node).gt.0) then

              call date_and_time(date=bresult1,time=bresult2)               !jd
C             read(bresult1,'(i4,i2,i2)') yy,mm,dd                          !jd
              read(bresult2,'(i2,i2,f6.0)') hh,min,ss                       !jd
              write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss       !jd
              if(bresult(7:7).eq.' ')bresult(7:7)='0'                       !jd
              call writint(anode,node)                                      !jd
              call writint(ajob,stat(node))                                 !jd
              write(irmr,1013) bresult,trim(anode),trim(ajob)               !jd
1013          format(3x,a,':- communications failure on node ',a,'; ',      !jd
     +        'model run ',a,' will be re-assigned to another node.')       !jd
C              print '(A,I4,2A)','FAILED job',STAT(node),
C     |          ' on node ',TRIM(BEOTEXT(node))
#ifdef FLUSHFILE
              call flush(irmr)                                              !jd
#endif
              MODE(STAT(node)) = -1
            endif
C   Mark slave as offline
            STAT(node) = -1
          else if(bsn.eq.0)then                                             !jd

C   Check that no runs are overdue.

            if(stat(node).gt.0)then                                         !jd
              if(mode(stat(node)).gt.0)then                                  !jd
                if(suspect(node).eq.0)then
                  if(av_operating.ne.0)then                                       !jd
                    current_walltime= walltime()-strt(node)                     !jd
                    if(current_walltime.gt.3.0*average_walltime)then            !jd  !abitrary
                      suspect(node)=1                                           !jd
                      mode(stat(node))=-1                                       !jd
                      call date_and_time(date=bresult1,time=bresult2)           !jd
                      read(bresult2,'(i2,i2,f6.0)') hh,min,ss                   !jd
                      write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)')             !jd
     +                hh,min,ss                                                 !jd
                      if(bresult(7:7).eq.' ')bresult(7:7)='0'                   !jd
                      call writint(anode,node)                                  !jd
                      call writint(ajob,stat(node))                             !jd
                      write(irmr,1014) bresult,trim(anode),trim(ajob)           !jd
1014                  format(3x,a,':- overdue run on node ',a,'; ',             !jd
     +                'model run ',a,' may be re-assigned to ',                !jd
     +                'another node.')                                          !jd
#ifdef FLUSHFILE
                      call flush(irmr)                                          !jd
#endif
                    end if                                                    !jd
                  end if                                                      !jd
                end if
              end if                                                        !jd
            end if                                                          !jd
          endif
        enddo

C  Scan slaves to find the fastest idle node
        idle = 0
        fast = 1d300
        do node=node0,node1
          if(suspect(node).eq.0)then                                         !jd
          if (STAT(node).eq.0 .and. BEOWALL(node).le.fast) then
            fast = BEOWALL(node)
            idle = node
          end if                                                             !jd
          endif
        enddo
C  Find next unscheduled job
        do next=1,NJOB
          if (MODE(next).lt.0) goto 100
        enddo
        next = 0

C  Push next job to idle slave
100     continue
        if (idle.gt.0 .and. next.gt.0) then
          if(waitflag.eq.1)then                                          !jd
C            write(6,101)                                                 !jd
C101         format('    Node has appeared; commencing a model run.',/)   !jd
            waitflag=0                                                   !jd
          end if                                                         !jd
          STAT(idle) = next
          MODE(next) = idle
C  Retrieve parameters
          call RETRIEVE_PARALLEL_REGISTER(IOS,
     |      NPAR,PARREG,next,PAR,PARREGFILE)
          if (IOS.ne.0) call BEOFATAL('Cannot retrieve PAR ')
C  Push to slave
          call BEOPUSH(idle,PAR)
C  Write to the run management file.
          call date_and_time(date=bresult1,time=bresult2)                !jd
C         read(bresult1,'(i4,i2,i2)') yy,mm,dd                           !jd
          read(bresult2,'(i2,i2,f6.0)') hh,min,ss                        !jd
          write(bresult,'(i2.2,'':'',i2.2,'':'',f5.2)') hh,min,ss        !jd
          if(bresult(7:7).eq.' ')bresult(7:7)='0'                        !jd
          call writint(anode,idle)                                       !jd
          call writint(ajob,next)                                        !jd
          write(irmr,1011) bresult,trim(ajob),trim(anode)                !jd
1011      format(3x,a,':- model run ',a,' commencing on node ',a,'.')    !jd
C  Nothing to do right now so sleep a spell before trying again
        else
          call MSLEEP(5)
        endif
      enddo
C  Count model runs
      NCALL = NCALL+NJOB
      go to 9999                                                            !jd

9891  jfail=1                                                               !jd Make sure calling program handles this


9999  continue                                                              !jd
C  Done - free MODE and STAT arrays
C      deallocate(MODE,STAT,stat=ierr)                                       !jd
C      deallocate(PAR,stat=ierr)                                             !jd
      if(irestart.ne.0) close(unit=ptunit,iostat=ierr)                      !jd
      return                                                                !jd

      END
C**********************************************************************C
C**************  Get number of 'fast' slaves available  ***************C
C**********************************************************************C
      SUBROUTINE FASTSLAVES(NUMSLAVE)
      USE BEOPEST
      IMPLICIT NONE
      INTEGER          NUMSLAVE,node,node0,node1
      DOUBLE PRECISION fast,BEOWALL

C  Check for new nodes and get range of nodes
      call BEONODE(node0,node1)

C  Find fastest node (0 means new)
      fast = 1d300
      do node=node0,node1
        fast = MIN(BEOWALL(node),fast)
      enddo
      fast = max(fast,1D0)

C  Count nodes faster than 2*fast
      NUMSLAVE = 0
      do node=node0,node1
        if (BEOWALL(node).le.2*fast) NUMSLAVE = NUMSLAVE+1
      enddo
      END
C**********************************************************************C
C***********************  Read instruction file  **********************C
C**********************************************************************C
      SUBROUTINE READINS(LCINS,NINSTR,A,ASIZE,MRKDEL,JFAIL)
      USE PESTDATA
      IMPLICIT NONE
      INTEGER NINSTR
      INTEGER I,J,INS,ISUM,LCINS(NINSTR),ASIZE,NBLC,JFAIL
      CHARACTER MRKDEL(NINSFLE),A(ASIZE)

      INS  = 0
      ISUM = 0
      do I=1,NINSFLE
        call FFOPEN(JFAIL,INST,'r',INSFLE(I),78,CLINE)
        if (JFAIL.ne.0) RETURN
        read(INST,*)
        INS = INS+1
        CLINE(1:1) = CHAR(2)
        CLINE(2:2) = ' '
        CLINE(3:LEN(CLINE)) = OUTFLE(I)
        LCINS(INS) = ISUM+1
        do J=1,LEN_TRIM(CLINE)
          ISUM = ISUM+1
          A(ISUM) = CLINE(J:J)
        enddo
50      READ(INST,'(A)',END=180) CLINE
        call TABREM(CLINE)
        if (INDEX(CLINE,MRKDEL(I)).eq.0) call CMPRSS(CLINE)
        NBLC = LEN_TRIM(CLINE)
        if (NBLC.eq.0) goto 50
        INS = INS+1
        LCINS(INS) = ISUM+1
        do J=1,NBLC
          ISUM = ISUM+1
          A(ISUM) = CLINE(J:J)
        enddo
        goto 50
180     CLOSE(UNIT=INST)
      enddo
      END
#endif
